About

Lightweight and powerful, fully shell integrated, and extremely usable for increased everyday productivity, 2xExplorer is an ideal dual-pane replacement for Windows Explorer; compatible with all 32-bit Windows platforms. A Swiss Army knife for your everyday file management needs.

helpfile by entellitech.com


Introduction

Windows Explorer is a decent entry-level file manager, capable of allowing even one's grandmother to become an instant file manager-ess. The point and click, drag & drop paradigm is very intuitive and gives access to immediate no-frills basic file management. However, for the more dedicated user who owns his/her computer for more than a month or two, and whose interactions with the machine extend beyond surfing the net, the fundamental cracks in the said explorer become apparent.

Have you ever wished the standard Windows Explorer was a little bit more efficient for the day-to-day file management tasks? Are you longing for the functionality of older file managers but can't find one that is 32-bit compatible? Do you find some applications in the explorer replacement market a bit too taxing to setup and use? Then look no further, 2xExplorer is the answer and twice as nice at that. It combines the user-friendliness of the standard Explorer with the increased efficiency and advanced features of good-old dual-pane file managers like Norton Commander. It is a package that will appeal to the power user, yet its similarity with Explorer will ensure that less experienced users will not be driven away either.

2xExplorer is a fusion between the efficient dual-pane file management format of yesteryear and the intuitive tree/content pane format of modern operating systems. It aims to deliver the best of both worlds, without pledging allegiance to either of the two prototypes. You may regard it as an explorer on steroids, with an additional pane for browsing folder contents side to side. Apart for this extra pane, 2xExplorer fills in many glaring omissions in the windows Explorer:

· Filters (wildcard based) for limiting the files displayed in a contents pane, and for controlling the selection of items.

· Keyboard shortcuts for nearly all commands, an indispensable feature for efficient everyday use.

· Briefcase-beating lightweight folder synchronisation engine.

· Notepad-thrashing internal simple yet powerful text editor and RTF/Hex viewer.

· Improved Find Files tool offering more control over the search criteria.

· Printing of folder contents and other statistics.

· Automatic Batch file (*.bat) generation that can be used for delicate management operations, as the mass renaming of files.

· File and folder shreder (complete destruction).

· File split & merge commands.

· Create hard links to files and folders (NTFS).

· Complete file date information (modified plus created and last accessed) is both shown and used for various operations throughout the program.

· Proper sorting for file type using the filename extension alphanumerically; no more ".INI" files before ".BMP" ones like in the confused explorer.

2xExplorer offers a host of powerful commands found in heavyweight file managers like Norton Commander, yet it is not poised to reproduce faithfully the original item. The author makes no apology for departing from the traditional looks and modus operandi that some NC purists would regard compulsory for any file manager braving a comparison with the founder of the dual pane scene. For example, there seems to be little justification for two sets of toolbars (i.e. drive buttons, status bars, etc.) - one for each pane. Despite this external dissimilarity though, you'll soon realise that 2xExplorer is every bit as efficient, useable and addictive as NC. In fact it surpasses the master in providing all mod cons of an up to date 32-bit shell namespace browser:

· Browsing and file management in non-filesystem folders like Control Panel, Desktop, zipfolders etc.

· Full drag/drop (including right-dragging) and shell context menu support.

· Multifunctional address bar for specifying folder names and visual filters, plus running (executing) DOS or windows programs.

· Bookmarks and internet-style back/next folder navigation.

· Separable tree view; one can have both the tree view and the two contents panes visible at the same time.

· Thumbnail previewer for many popular graphics formats (jpeg, gif, bmp, etc.), HTML and Office documents.

· Handy tools like the Folder Subtree Statistics and the unique Mirror Browsing tool.

· Autocompletion for paths and other frequently typed information.

· Copy pathnames and preview bitmaps of selected items.

· Optional single-click activation schemes for both views and tree.

All this functionality does not come at the expense of user friendliness. In most respects this is just another Windows Explorer, and whoever is familiar with that, will feel immediately at home using 2xExplorer. The look is not far off the standard Explorer either; one will even see the same "animations" in copying/deleting operations. Descriptions of commands are readily available in the form of explanatory text on the status bar and tooltips popping out of toolbar buttons. Dialog windows have embedded brief instructions of use - with complimentary icons too. 2xExplorer is capable of making instant power users out most people, regardless of their level of experience.

All the features of 2xExplorer are supported for all 32-bit windows platforms, from win95 all the way up to the latest winXP (i.e. 95/98/NT4/2000/Me/XP). The code is fairly stable and you shouldn't experience many mysterious program crashes and blue screens of death. Keep in mind that 2xExplorer works at a very low level, hence crashes cannot be ruled out altogether, especially for systems that are heavily tweaked.

Last but not least, 2xExplorer offers all this increased functionality whilst retaining a "small" executable file size. Half-megabyte programs would be regarded monstrous 10 years ago, but with all these COM and user interface features nowadays 500 kB is at the low end of the market. Still don't let that fool you, there are heaps of functionality efficiently packed in this lightweight outfit. The file size was kept in check by sensible program flow design, taking advantage of many C++ language features for the maximum level of code reuse possible. This same feature explains in part the speed of the program, too.


Dual Pane Layout

Anybody that has ever worked with a dual pane file manager will surely attest to the one thousand plus one different uses that the extra contents pane can be put into, for increased efficiency. In 2xExplorer the contents of two folders are visible at any given time. Each of the two panes behaves similarly to the right hand side pane of the standard Explorer, and can be configured completely separately in all property departments (e.g. view style, sorting method etc.).

However, the dual pane layout is much more than the sum of its parts. It's not the same as merely placing two explorer windows side by side, since the panes can communicate with each other. Here are some manifestations of this functionality:

· One stop copy/move operations. Perhaps you find the separate "copying" followed by "pasting" too big a fuss to endure; perhaps you want to see for yourself and verify where your files end up to. 2xExplorer covers all these issues. The presence of two panes provides straightforward target and source folders for these operations. The active pane (be it the left or right one) is always the source folder. The target will usually be the "other" (opposite) pane; however, an alternative folder can be specified if necessary. Hence a copy or move operation can be carried out with a single keystroke.

· Folder synchronisation. The panes can compare their respective contents and mark all files that are missing or different, so as to bring the two folders in perfect harmonisation. For more information refer to the synchronisation section below.

· Mirror browsing. Assisting the synchronisation/comparison of whole directory subtrees, this is a world-first feature delivered by 2xExplorer. When turned on, the inactive pane will mirror the hierarchy navigation applied to the active pane. Let us consider an example: initially, "C:\Documents\Project" is shown in the active pane (A) and "A:\" in the inactive pane (I). With mirror browsing, moving (A) down into "C:\Documents\Project\Resource" will result in the (I)-pane automatically switching to "A:\Resource", should such a folder exist. If you hit <Backspace> to go one level up then (I) will go one level up too.

· Synchronised scrolling. Activating this option results in tracking the focus cursor ("selected" item) movement in the active pane and trying to match it in the inactive pane. The match aims to locate items with the same name that can be thus individually compared head-to-head. Turning both panes into the Details view mode will maximise the usability of this feature, since 2xExplorer will even try to align both items horizontally, if possible.

The team work between the panes goes even further with commands that load the same folder into the inactive pane, using the <Alt> modifier (see Efficient Folder Navigation section below) to force-feed its address, and so on. Once you've sampled the advantages of the dual pane format, there's no going back to half measures any more.


File Management

2xExplorer is a beast of burden ploughing through all your day to day file management needs. You can do all the usual operations like copying, moving, deleting and renaming, with either the mouse or the keyboard, just like the standard Explorer. No need to reconfigure your mind and/or take special training courses there. However, the similarity stops here. 2xExplorer is capable of taking on large folder hierarchies and efficiently managing large amounts of files. It will allow you to get swiftly where you want and increase your productivity once you get there.

There are two main concepts that facilitate managing large scale folders: visual filtering and a multitude of item selection mechanisms. 2xExplorer uses filters to constrain the number of items displayed in each pane. Traditional wildcard patterns are recruited for this, using the special characters "*" to match any number of any characters and "?" to match any single character, like in the good-old command line days. Multiple patterns can be easily specified in a comma separated list, e.g. the filter "*.cpp, *.h" will result in showing all files having 'cpp' or 'h' extensions and nothing else.

For even greater control, it is possible to exclude certain kinds of files, by specifying a leading minus '-' character in some substring. For instance "*.cpp, -a*" will select all 'cpp' files except those whose names begin with 'a', and "-*.txt" would select all files except those with 'txt' extensions. This comma-separated list concept is a great efficiency boosting gadget that is used throughout the application, solving all sorts of problems.

All the file management operations require selected items to act upon. 2xExplorer comes in handy in this department too, with its virtual selection engine. Items can be picked individually if clicked with the mouse (possibly while holding down the <Ctrl> key) or with the <Ins> key. Larger selections are possible with <shift>-clicking, lasso selection and all the other means supported by the standard explorer. As you'd expect there's more on offer, in the form of selection criteria:

· Filters may be used for selecting and unselecting items out of those that comply with the visual filter specified earlier. The comma-separated filter list is applicable here too. Note that selection filters are totally independent of visual ones.

· Using the range of synchronisation commands (see next section) items can be selected if found to differ among the two panes shown.

· Items can also be marked if found to be containing some user-supplied text. Although not a full-blown grep (familiar to UNIX users) equivalent just yet, the command accepts a large degree of tweaking with options to control the case sensitivity of the search, for excluding binary files from the scan, etc.

Complementing these selection/unselection methods are various small touches like inverting the selection, storing the selected names for later use, specifying whether subsequent selections will be added on top of the present one, a sticky selection mode and more. Ingenious use of these small building blocks will tackle any arbitrarily complex selection formula - limited solely by the user's imagination.

2xExplorer is fully aware of shell shortcuts (links) to files and folders, and handles them correctly. For example, if you drag-drop some files on a folder shortcut, the files will be properly sent to the real target folder. Also the <Ctrl+L> FindTarget command is very useful for quickly locating the target item of any shortcut file.


Folder Synchronisation

Folder Synchronization

Personally, I have suffered so many devastating blows during my long-term symbiosis with computers, that have developed a nearly-psychotic tendency to backup every piece of important working file. Note that I am not referring to once a month - or even weekly - backups; if some dark cosmic eventuality causes my losing even one hour's worth of work I feel gutted. It is the well known universal law of the sod that things will pack up the very moment that absolute reliability is at a premium. The text editor will delete the thesis you were working on, the developer studio will crash and corrupt your C++ source files, even the operator himself is liable to malfunction after long hours and do the daft thing. These are all too familiar sights that are capable of driving even mother Teresa through the wall, if under pressure.

The answer to these kinds of hiccups is to do frequent "backups" onto a floppy disk, at a rate inversely proportional to your insecurity factor - that's every 10 minutes if your name is Nikos. For that purpose you need a very efficient and fast tool that can automatically detect the files you've modified and quickly copy them to their secure haven. Well, you've guessed it, 2xExplorer does just that with a variety of synchronisation commands.

You don't have to share the author's paranoia to appreciate the synchronisation features. Any person that works in a couple of different locations will need a means of keeping the contents of the two computers in sync. If you want to continue your labours at home after a long day's work, you'll have to transfer your project files via a floppy disk. Given the sluggishness of file transfer to/from floppy media, the capability to detect and copy only modified files is invaluable. 2xExplorer does not suffer from the same limitations as the Windows Briefcase which is badly constrained by binding to two specific fixed folders. The synchronisation of any two folders can be examined in a flash using the following palette of commands:

· Plain synchronisation. Common as garden grass, this is a very quick way to detect modified files, by looking at the date stamp information of all filenames that exist in both panes (new files that exist only in one pane are straightforward subjects for synchronisation). A later date will result in this file considered more recent and thus marked by 2xExplorer. Note that the files are only marked as suggested for copying; it is up to the user to decide what to do with them. Copying would be the sensible option but nobody could stop you from deleting or performing any other sensible action.

· Contents synchronisation. Sometimes the date stamp information is inadequate for comparing file versions. For instance, copying files from a windows PC to a UNIX computer messes up the modification dates; FTP transfers may suffer from the same symptom. In such cases the last modification date is not a reliable indicator, and the contents synchronisation comes to the rescue. This is a slower method since files have to be physically opened and their contents read in memory to determine their differences or otherwise. Moreover when two files are found to differ, 2xExplorer has no means of telling which one is the most recently reviewed version, therefore only files in the active pane are marked. It is the user's responsibility to discern which version to keep and which to junk. Despite these inevitable shortcomings, content synchronisation can be invaluable when the going gets tough.

2xExplorer offers lightweight synchronisation as opposed to full-blown backup services. The emphasis is on efficiency and user control of what's being transferred, as this feature is meant for very frequent use. Only the contents of the two folders that are shown in the active/inactive panes are considered each time. Still, subfolder synchronisation can be assisted by the mirror browsing feature mentioned earlier.


Internal Editor/Viewer

With 2xExplorer, the contents of each file can be examined without resorting to the default associated application, by either viewing or editing it as "text" (naturally the double-click mechanism is still supported). This feature in a sense provides a second "association" for each file. Since the editor is embedded in 2xExplorer, it provides access to the file contents much faster than e.g. using Notepad. The Notepad-beating capabilities are not limited to speed though. It features drag/drop editing, word wrapping, printing, unlimited size editing, plus it sports a handy toolbar for frequently used commands.

Although it won't substitute your main editor (say for writing your source code), it is nevertheless a very compact quick'n'dirty utility to be appreciated by programmers and lay users alike. The key objective is efficient everyday use, facilitated by the following main features:

· Keyboard shortcuts for most commands

· Powerful search and replace, including command history and cyclic search

· Font selection, colour customisation and tab settings

· Hexadecimal viewer for binary files - for the hacker within oneself

· Rich text format (RTF) viewer in read only mode

· Autotext for easing the insertion of opening/closing HTML tags and other text.

Especially for programmers of all shapes and languages, the following added items would surely prove handy:

· Indentation control

· Brace matching, including HTML angle brackets <>

· Goto line # command

· Line/Column indicator

· Insertion caret bookmark

The internal editor is also available in a feature-improved standalone version, for people that want to permanently associate all text files with it. This version offers Unicode and Unix text file support, too. Just visit the website and download Editor².


Integrated Find Files Command

The standard windows Find Files utility is just beginning to catch up with the functionality offered by the 2xExplorer's internal item - and not in all departments. Still, you don't have to splash out for the latest version of Windows XP to have a decent file search utility, when 2xExplorer provides all these features for all earlier win32 platforms (9x/NT4 etc), too:

· Multiple file filters (file types) to locate.

· Many search "root" folders can be specified to look in.

· Date-constrained searches can use all three pieces of file date stamp information (modified, created and accessed). The minimum timeslice supported is an hour, which may help pinpoint recently changed files.

· Text-constrained searches can be refined by options like case sensitivity, word search, and the time-saving option to exclude binary files (regardless of exact type) from the searched list.

The find results window is a modeless dialog, which means that it can be left open without interfering with the normal operations in 2xExplorer. The main purpose served is to load and highlight the items found in one of the regular 2xExplorer panes, where any further operations may take place if need be. The range of supported commands in the results window itself is limited, as accessible via a context menu. In this sense it behaves differently to the standard windows Find Files utility; if you prefer the latter you can invoke it from within 2xExplorer using the shell context menu (right-clicking) on any folder item in the two panes or tree view.

The search results can be printed using the context menu. Also you can create batch files using the standard command templates (see the batch file creation section below)


Advanced Features

2xExplorer was developed for non-frustrating everyday use in mind. Following is a list of features that will be appreciated under this light, by all people poised with seeking maximum efficiency and optimization in their lives - some jealous and/or incompetent folk would maliciously use the term "control freaks" here. :¬)


Efficient Folder Navigation

There are so many different ways to move around your filesystem hierarchy that you are truly spoiled for choice:

· Using the address bar to key in paths, or to select a folder browsed earlier from the drop-down history portion. Buttons/shortcuts for moving to parent/root/desktop folders will also be found here.

· Dragging folders or files from your desktop and dropping them on the address bar is equivalent to typing their full path, and takes you directly to their location.

· Using the tree view to select any folder in all the filesystem hierarchy.

· Using the DriveBar for quickly accessing all disc drives installed on your computer (a similar functionality is available via the Tools | Select Drive command).

· Using the navigation chain, which allows moving to folders browsed earlier/after in the familiar Previous/Next mechanism popular with internet browsers. 2xExplorer also remembers the last item that had the focus and reinstates it when a folder is revisited.

· Using the bookmarks, which are shared by both panes.

· Many modeless dialogs that show filesystem trees (e.g. Folder Data, Find Files results) can also be used to change folder by double-clicking.

Since there is just one set of controls (e.g. tree, driveBar, miscellaneous buttons, etc.) shared among the two panes, any navigation command will normally affect the active pane. However, by holding down the <Alt> key the command will be directed to the inactive pane. This is a very useful feature which importance for improving browsing efficiency cannot be overstated enough. The <Alt> modifier works universally for all browsing commands mentioned above, regardless if they are keyboard or mouse-oriented. For example, you can hold <Alt> while double-clicking on a folder displayed in the tree view, while pressing <Return> in the address bar, while using <Backspace> to move to the parent directory, and so on.


Multi-purpose Address bar

The address bar is multi-functional, accepting pathnames, visual filters or both at the same time. This is a handy feature allowing a single focal point to be used for all text-input requirements, doing away with the need for separate time-consuming sessions in dedicated dialog boxes that are found in rival file management applications.

Concentrating on the addressing functionality, either absolute or relative paths are accepted, including any combinations of the parent ("..") and root ("\") folder specifiers. In many occasions addressing a folder by its name is much faster than furiously clicking here and there, especially if the target folder is more than a single step away in the hierarchy tree. Finally, it should be noted that all the boxes that accept paths in 2xExplorer (throughout the application, as e.g. in the Copy dialog), have similar "smart" parsers supporting them, and are fully path-"conscious", both for relative and absolute paths. For instance the difference between "C:" and "C:\" is properly resolved. UNC paths are also supported, allowing direct browsing of resources in other computers in a network (e.g. "\\share\~umeca74"). Finally, it is possible to include a filename as a part of the path, which results in browsing the folder and selecting the filename specified at the same time.

Except for addressing, the bar can also be used for entering commands to execute, for both DOS and 32-bit windows programs. In order to differentiate command execution from normal addressing, 2xExplorer interprets as commands inputs that begin with '$' or '>' characters. 2xExplorer also simplifies the compilation of argument lists, since it enables copying filenames from the active pane directly into the address bar, using <Ctrl+arrowKeys> to select names and <Ctrl+Return> to transfer them. Path names are easily accessible with the $L and $R constructs, for the left and right pane respectively, as is the focused filename with $N (similar to the GenerateBatch command, see below). The tokens $P and $I stand for the active and inactive pane paths, respectively. Their use is similar to $L and $R but the former pair can be used for composing more generic reusable commands, independent on the pane that happens to be active. Finally environmental variables like %WINDIR% can be used as part of the commands — these are automatically expanded by 2xExplorer.

The drop-down portion of the folder address selection combo box lists the names of the folders that have been recently visited. This allows rapid switching backwards and forwards between folders, if need be. This list is different from the navigation chains maintained by each pane, since the latter are specific to each pane whereas the former is a shared resource.

Histories of other items entered in the address bar, like visual filters and commands, are also maintained. Naturally, there's no room for them in the drop-down portion; access is offered via items in the Files and Tools menus, respectively.


Smart Keyboard Shortcuts

2xExplorer is also known as the "keyboard-junkie's"-Explorer. A design specification of the program is to provide keyboard shortcuts for all important and commonly used commands. Most accelerators are shown next to the respective menu command and are also included in the tooltips, acting as a quick reminder. For many useful "undocumented" shortcuts please refer to the accompanying Keyboard.txt file.

2xExplorer caters for the needs of a sizeable portion of computer users who prefer the keyboard for applications they use daily. With long term use it is easy to memorise the keyboard equivalents of most frequently used commands, which enable one to do things with lightning speed compared to using the mouse - that's the typical "man or mouse" dilemma. Why bother with target practising or do battles with clogged up and foul mouse roller balls, when paradise is just an arm's length away? 2xExplorer won't test your patience when you use it daily, even after the initial impressions have been long since worn off. That's the recipe for healthy long-term "relationships" IMHO.

Another useful attribute here is that the <Ctrl> key can be used to modify the behaviour of an accelerated command. For instance, the <F5> key used for copying will normally summon a dialog box, requesting the target folder for the operation. Although the "opposite" pane folder name will be usually pre-selected, and the only action required from the user would be a single Return key press for acceptance, wouldn't it be better if one could do away with the dialog box altogether? That is exactly what the Control key does as a modifier to commands like Copy: pressing <Ctrl+F5> will result in an immediate copy, dispensing with the dialog. All commands that use an intermediate dialog box and could somehow accept a default answer without any user intervention can be similarly modified using the Control key. For full details refer to Keyboard.txt.


Folder Subtree Data

Inquisitive minds will surely find the summary information offered by a standard property page of any folder to be rather on the brief and utterly unsatisfying side. 2xExplorer provides detailed information about a folder including detailed breakdown of the included files and sub-folders (and the respective storage space occupied) all the way down to the last sub-folder in the hierarchy tree.

The results are presented in an intuitive tree fashion, hosted by a modeless (and resizable) dialog window, which can remain open for as long as one likes. That will help you to figure out exactly how on earth all these megaBytes managed to pile up in the windows directory.

Right-clicking on this window opens a context menu which may be used to sort the items and even print the fully expanded tree of information.


Extended File Date Information

All 3 pieces of file date/time information available (last Modified, first Created and last Accessed) are available in the details view - by selecting the relevant property from View | Options page - unlike the Explorer where only the last modified time can be seen. This feature, except for allowing easy access to file time stamp information, also enables the sorting of files using dates other than the modification one. This is useful in many cases where one would like to detect e.g. files that have been recently accessed (without being modified). Those nasty virus and/or install programs will no longer hide their activities from power users!


Batch File Creation

Except for the regular operations on selected files/folders, there is a special treat for all the old hands out there, that most probably would have wished for a similar capability all those years back in the dark DOS ages. Enter the batch file generator. Using a command template with special characters for the path/filename/extension, it is possible to apply the same series of commands on each selected item with minimum effort. The following special characters are supported in templates:

$N for full filename (e.g. object.cpp)

$B for base filename (e.g. object)

$E for filename extension (e.g. cpp)

$L for left pane full path name

$R for right pane full path name

$P for full path of the focused item's name

$I for inactive pane's full path name

$xx for an automatically incremented number (see explanation below)

Typical uses of this command include the mass-renaming of file extensions (using a template as "ren $N $B.other"), touching the date stamp information, and so forth. You'll surely regret deleting them ms/dos commands!

The tokens $P and $I are generalizations of the $L and $R tokens and are preferred for building up a battery of reusable command templates. The active pane in 2xExplorer determines the current directory in the traditional DOS sense. The $L/$R tokens usually require a particular pane to be active for a command to be executed properly, whereas the new $P/$I break this asymmetry. For instance whereas the command "copy $N $R" could only be used when the left (top) pane was active, its novel equivalent "copy $N $I" is valid from either left or right panes. The $P token is also extremely important for batch file generation from the find files result window, where items from many folders are displayed all at once. There $P correctly stands for the path of each item.

Mass-renaming is made easier by using counters, which are numbers automatically incremented by one for each line generated. Name sequences like file01, file02,… are easy to construct with the special template "file$01". You have the flexibility of specifying both the starting value of a counter and the number of leading zeros; for instance, the counter "$0012" will start counting from 12 and add enough leading zeros to ensure a 4-digit number.


Advanced file management

Except for the normal copy/rename/delete file operations, 2xExplorer offers a range of advanced file management commands. Shredding completely destroys files by deleting them after first overwriting their contents with 0s. Large files may be split in chunks of specified sizes so as to e.g. fit on a floppy disk; these may be subsequently merged to recreate the original large file. File modification dates can be touched to synchronize them with the CPU clock.

Except for normal shortcuts, 2xExplorer can paste hard links to files and folders. Hard links are a more direct way for providing access to files from many locations since the direct file is exposed circumventing the requirement for a "pointer" shortcut file. Hard links look in all aspects like the original file, but point to the same physical disk location, hence storage is not wasted whilst changes made to a link automatically propagate to the original file (or vice versa). The major limitation is that both the original and the hard linked version must reside on the same NTFS partition.


Command Line Arguments

2xExplorer can be started with optional arguments (e.g. using a desktop shortcut). The command line can be used to override various default program settings, and markedly so the initial directories displayed in its panes. The syntax is as follows:

> 2xExplorer [leftFolder [rightFolder]] [/S:<name>]

All arguments are optional. The initial folder arguments can be utilised to make 2xExplorer the default file manager of your system; preferably you should specify full pathnames here. The /S option controls the registry key name where all the persistent program properties are kept (window size and the rest). By default, 2xExplorer will store everything in "HKEY_CURRENT_USER\Software\ZabaraKatranemia Plc\2xExplorer"; using the (for example) /S:OTHER argument will force properties to be stored/read from the "HKEY_CURRENT_USER\Software\ZabaraKatranemia Plc\2xExplorerOTHER" key instead. This feature can be handy for keeping various shortcuts in your desktop, each with different settings.


Layout Management

2xExplorer uses advanced layout management to arrange the numerous toolbars that provide useful services. All bars can be either docked or floating, or even hidden if not required. Moving toolbars around is simple as long as you find an "empty" spot to drag them from. Holding <Ctrl> pressed will force a toolbar to float, so that it can be placed outside the main 2xExplorer frame window and/or resized. Special bars like the folder tree can be resized even while docked. The management algorithm permits having more than one bar sharing the same frame window edge while docked.

Given the large number of possible toolbar arrangements, 2xExplorer offers a mechanism to "save" a number of favourite distinct layouts and re-apply them at will at a later stage. For instance you may have an image previewing "mode", where the thumb control has a prominent position and one regular pane is hidden, another for regular file management where the window is maximised, and so on. The layout manager allows rapid switching among such different functionality modes. The information retained includes: window size/position, toolbar visibility/dock state/size/position, left/right pane sizes, even the view style of the panes (details, large icons, etc.).


General Usability

The author has pledged for the utmost usability of this program. All dialog boxes offer reasonable suggestions so that you won't have to do much typing yourself. Even in case you do need a bit of typing, the most appropriate field will be usually pre-selected so one can start altering the information immediately and mouse-free. Another anti-typing measure is the maintenance of history items, so there is no need to re-type what you just entered a short while ago. As a matter of course, most boxes meant for keyboard editing will have a drop-down part carrying the recent history information (combo boxes).

In order to make accessing previously typed information even easier, all combo boxes support autocompletion, which comes in handy when there are many strings in the history list. Just type in a few characters of the intended text, hit <up-arrow> and 2xExplorer will expand the string for you, searching the history list for the combo box in question. See Keyboard.txt for the full instructions.

All this history information is saved (in the registry) when you quit 2xExplorer, and is made available next time you restart the program. This holds true for all the program settings. Properties that affect the program operation (e.g. the overwrite confirmation in the Copy/Move dialog box), window sizes and positions, even the width of each column in the "Details" view, are persistent properties. So each time you restart 2xExplorer it's like you pick it up where you last left it - no messing about with resetting your favourite options.

Finally, 2xExplorer makes good use of the status bar to communicate various important messages to the user, avoiding intrusive message boxes that require user intervention to get them out of the way. These status messages will clear themselves after 5 seconds or so without giving you any hassle. That's exactly the fundamental concept behind 2xExplorer: a set of simple yet important touches that make one's long term relationship with computers less of an irritant and more enjoyable.

So, go on, let 2xExplorer make you more productive than thy neighbour!


Keyboard Shortcuts

2xExplorer provides keyboard shortcuts for most of its commands, which is a major asset when it comes to efficient everyday use. The accelerator for a command will be usually found next to its menu item. For your convenience, accelerators are also shown in the tooltip texts of the various toolbar buttons, enclosed within brackets.

This file contains some useful 2xExplorer commands that do not appear in any menu or toolbar. They are only accessible via their keyboard equivalents that are listed below. The various commands are grouped in terms of relevance.


Item Selection

2xExplorer offers a wide range of commands for selecting (highlighting) items, which use various criteria to match files (e.g. according to a name pattern). Nevertheless, in some cases the easiest way to modify the selection state of a group of files/folders is to manually select or unselect them. You can do that either with the Insert key or with the mouse, as shown below. See the next section for methods of moving the focus cursor around the pane (and the important role of the <Ctrl> key for protecting a selection pattern).

ACCELERATOR | DESCRIPTION OF COMMAND
Insert | Toggle the selection state (select if unselected and vice-versa) of the item under the (focus) cursor and move down
Ctrl + Space | Toggles selection as <Ins>, but won't move the focus cursor
Shift + Click | Extend the selection up to the clicked item
Ctrl + Click | Select/Unselect an individual item, without affecting the selection state of the remaining items
Alt + D | Select all (and only) folders
Alt+Shift+D | Unselect all selected folders

Using the mouse you can also select items by drag-drawing an enclosing rectangle ("lasso") as per the standard explorer.

When the Sticky selection mode is activated the mouse can also be used to toggle some item's selection just like the <Insert> key. This mode protects any existing selection against accidental clicks or key presses.


Cursor Movment

The focused item is central to 2xExplorer. In each pane there is only one focus, recognized by the dotted rectangle drawn round the item name/details. The focused item is not necessarily selected at the same time. 2xExplorer automatically sets the focus after carrying out some commands, as for instance after synchronisation <F9>. The focused item is always visible; in case it is automatically set 2xExplorer may need to scroll the pane contents to ensure this visibility.

Initially the focus is set to the first item listed in the folder, except if the folder was visited earlier, in which case the last focused item is restored. You can change the focus manually by clicking with the left mouse button or with any of the following keys:

ACCELERATOR | DESCRIPTION OF COMMAND
Arrow keys | Move the focus cursor to the respective arrow direction (*)
Home/End | Move the focus cursor to the beginning/end of list (*)
PgUp/PgDn | Move the focus cursor a "page" (screenful) up/down (*)
<letter> | Move and select the first item whose name begins with (**) <letter>; can be used with more letters/ sub-strings, too
Shift+<letter> | Similar to the above but here the letter/substring is matched against the extension of filenames (useful for cases where a pane is sorted by extension)
Alt + Down | Move the focus to the next item selected
Alt + Up | Move the focus to the previous item selected

(*) IMPORTANT: Care should be exercised when using the arrow keys and the other cursor relocating keys (Home etc.) on their own, since any unqualified key-press will UNSELECT all items (unless sticky mode is on, see below) except the one that the cursor will eventually end upon---hence running the risk of destroying a selection pattern in a swift stroke, which is definitely not amusing at all. Unfortunately this is the standard behaviour of the Windows List Control and there is no simple way around this "problem". However, it is possible to move around using the arrow keys and protect the selection state at the same time, if the <CONTROL> key is simultaneously kept pressed. Technically this causes the relocation of the focus item only, i.e. the one that has a dotted rectangle drawn around it (the so called focus rectangle). Starting from version RR-t, you can protect a valuable selection against accidents using the Mark|Selection|Store <Ctrl+F11> command.

STICKY SELECTION: The problems just mentioned disappear when sticky selection mode is on. There you can use the keyboard and mouse freely without risking loss of any prior selection.

(**) NOTE: The same trick for "incremental" item selection can be also used within the tree pane.

Finally, when the Synchronised Scrolling <Ctrl+Y> option is enabled, a change in the focused item in the active pane is mirrored in the inactive pane, too, if possible (i.e. if a file with the same name exists in the "other" pane it will be focused).


Pane Activation

Only one pane is active at any given time, the one whose title bar resembles a selected window. The active pane is important since all file operations like copy, delete, etc. are sourced from there. A pane can be activated by clicking anywhere on it (click on the title bar to protect any previous selection pattern). The two panes along with the folder history combo box in the address bar and the tree pane (if visible) can be considered as a "chain"; use the following keys to cycle round:

ACCELERATOR | DESCRIPTION OF COMMAND
Tab | Cycle between left/right panes
Left/Right | Arrows behave like <Tab> when both panes are set in details view
Shift + Tab | Jump to the folder history drop-down combo box
Ctrl + Tab | Jump to the filesystem tree pane
Esc/Tab | (from within the folder combo box or folder tree): Return to the active pane

To switch from the main 2xExplorer window to an editor/viewer window use the <Alt+Tab> standard windows task switching accelerator. To hop on and off from modeless dialogs like the find file results or the folder data window use <Alt+F6>.


Folder Browsing

You are spoilt for choice when it comes to methods of changing the folder being browsed in the active pane. Except for those contained in the toolbar/drivebar and the various menus, the following methods are also available:

ACCELERATOR | DESCRIPTION OF COMMAND
Return | Browse for folder or execute the file under the cursor
Double-Click | (equivalent to Return)
Alt + F1 | Select drive for the left pane
Alt + F2 | Select drive for the right pane
Ctrl+Shift+<letter> | Jump to the root directory of the logical disk <letter>(e.g. <Ctrl+Shift+A> will take you to "A:\" etc.)

The tree pane can be used for selecting a folder to load in the active pane. The same launching methods are used, i.e. pressing <return> or double-clicking on a folder. Tree branches can be expanded or collapsed using the left/right arrow keys or clicking on the [+]/[-] signs. To scroll horizontally the tree nodes (e.g. in tight width situations) use Ctrl+left/right arrows.

Both views and the tree have optional single-click activation modes which, although not recommended, can simplify item activation and folder browsing requiring just one click instead of 2. The tree's single-click mode turns on the "hands-free" activation, which is a delay-based folder selection without having to press the <Return> key.

Finally, a double-click on a pane's titleBar will take you up one level. This shortcut compensates for the lack of the traditional ".." pseudo-item found in some NC-clones.

THE <ALT> MODIFIER. Unqualified, all the commands for changing folder (navigating) affect the active pane. However, holding down the <Alt> key instructs 2xExplorer to apply the command to the inactive pane instead. For example, whereas <Bksp> takes you to a folder one level up (parent), pressing <Alt+Bksp> will force the inactive pane to switch to ITS parent folder. This mechanism even works when one clicks on the toolbar or drivebar, double-clicks in (say) the FindFile results window, tree pane, et cetera.

NOTE: If you need to use a shortcut that combines Alt+Ctrl (for example <Alt+Ctrl+0> to force the bookmarked folder 0 loaded in the inactive pane, or <Alt+Ctrl+Shift+A> etc), you must press Alt BEFORE Ctrl. This glitch is the side-effect of a patch that fixed problems with the <AltGray> key, useful for international keyboards.


The <CONTROL> Key Modifier

Many commands throw up a dialog window to gather information for the operation to be. Some times this information can be infered from the context, making the dialog a plain nag, serving no purpose other than lowering down one's productivity rates <g>. In such occasions the <Ctrl> key can be used as a modifier to the standard command accelerator key, so as to dispense with the offending dialog, as shown below:

ACCELERATOR | DESCRIPTION OF COMMAND
Ctrl+F5 | Direct copy of selected items to the opposite pane
Ctrl + F6 | Direct move of selected items to the opposite pane
Ctrl + Grey[+] | Direct marking of items using the last selection pattern
Ctrl + Grey[-] | Direct unmarking of items using the last pattern
Ctrl + F3 | Use the external viewer (an external editor must be specified in the general program options)
Ctrl + F4 | Use the internal editor even when an external editor is specified in the general program options

Note that for viewing files the internal applet takes precedence whereas for editing your custom editor (if any) takes precedence. The <Ctrl> modifier offers access to the secondary viewing/editing alternative.


Dragging Modifiers

Although right-dragging is supported in 2xExplorer, users may find that it is quicker/easier to perform some operations while dragging files normally with the left mouse button.

While left-dragging, the default operation depends on the drop location (e.g. whether the source/target folders are on the same device, whether the dropped file is an executable, etc). However, users are not limited to the default drag-drop operation; by holding down the standard (as per explorer) keys it is possible to explicitly set the intended file operation, hence making the use for right-mouse-dragging redundant. Even if you forget which key is for what operation, the changing mouse cursor shapes will act as a visual reminder.

MODIFIER | FORCED FILE OPERATION
Ctrl | Copy items
Shift | Move items
Ctrl+Shift | Create links (shortcuts) to items
Right button | Cancels the drag altogether (same as pressing Esc)

Note that both the active/inactive panes as well as the tree pane can be either drag sources or drop targets, and they all support drag scrolling, too.


Command Execution From The Address Bar

The address bar is normally used for specifying a path for a folder to be browsed and/or visual filters for files to be shown/excluded in a 2xExplorer pane. However, it is also possible to execute a windows or MS/DOS program by typing it's name (possibly with arguments) directly in the address bar. In order to instruct the bar to execute the line you key-in as a command (i.e. not as a path/filter), you should begin the command with the special '$' or '>' characters.

You can also copy item names from the active pane directly in the address bar, while you are composing the command line to be executed:

ACCELERATOR | DESCRIPTION OF COMMAND
Ctrl + arrows | Move the focus in the arrow direction in the active pane
Ctrl + Return | Copy the name of the focused item from the active pane into the address bar
Return | Execute the complete command

While you are composing the command, you may insert the special $L or $R tokens, which will be substituted for the full path of the left or right pane active folder, respectively. Keep in mind that if any pathname contains spaces you should wrap the whole thing in quotation marks (e.g. "$L"). Instead of using <Ctrl+Return> to copy the focused filename in the command you may use $N instead, which will generally result in more reusable commands, accessible via the run command history <Ctrl+F10>.

From version Z1 onwards, the tokens $P and $I can be used for the active and inactive pane path, respectively. This allows compilation of commands that aren't sensitive to which pane is active when a command is launched -- unlike the old $L/$R.

If you want to execute a command with the standard windows executor (Run command, located in Start menu), you can take advantage of the <WinKey + R> system accelerator. In this way it is possible to run programs that are not in the PATH variable.


Autocompletion For Combo Boxes

2xExplorer offers autocompletion in ALL it's combo (drop-down list) boxes where you type in information. That includes the address bar, the target folder in the CopyTo <F5> command, and so on. The behaviour is "similar" to internet explorer's autocompletion. The main difference is that 2x will try to autocomplete your "seed" (a small piece of text) by matching it against information you've typed before, which is present in the history of the specific combo box. The main advantage is that this seed can be anywhere in the target string, be it beginning, middle or end.

The autocompletion functionality does not pop-up automatically, you'd have to press <up-arrow> first. Let's consider an example. Say that the address bar history list contains the following paths:

A:\

c:\winNT\profiles\umeca74\MeDocs\C++

c:\winNT\profiles\umeca74\MeDocs\C++\cartman

d:\temp

If you type "C++" and hit <up-arrow>, then the first matching "c:\winNT\profiles\umeca74\MeDocs\C++" will be selected. Another <up-arrow> will fetch the next match "c:\winNT\profiles\umeca74\MeDocs\C++\cartman". That's the end of the line, since there's nothing else containing "C++" in the list. However you can press <down-arrow> searching for matches in the opposite direction. You can type in a new seed substring at any time. If you want to expand the drop-down window just press <Alt+down-arrow>.


Miscellaneous Commands

And finally some commands that cannot be grouped in any intelligible context:

[*] While dragging toolbars around, press <Ctrl> to prevent docking

[*] Double click on the splitter bar dividing the two panes to toggle

viewing one pane or two equally sized panes.

[*] Drag any folder/file from your desktop and drop it onto the

address bar to browse the target without typing the pathname.

ACCELERATOR | DESCRIPTION OF COMMAND
Esc | Aborts some lengthy operations as gathering "Folder Data"
Alt + Grey[+] | Mark all items that have the same extension as the focus
Alt + Grey[-] | Similar to the Mark "Like this one" command <Alt+G[+]>, but for unselecting items
Shift + Del | Delete the selected items immediately without transfer to the Recycle bin (CAUTION: this action can't be undone)
Alt+Shift + C | Copy selected items' path names in the short 8.3 format
Right click | Shows a popup menu depending on context (what and where is selected). Try it in many dialogs, too, for even greater satisfaction -- guaranteed! <g>

Note that the shell context menu of an item depends on its type, e.g. you'll find different menu entries if you right click on a folder compared to those of some (say) text file. If you hold <Shift> while right-clicking on an item the context menu will include an "Open with..." member. Finally, keep in mind that right clicking on items within "My Computer" folder gives access to many useful commands, like formatting floppy disks, etc.


Keyboard Shortcuts Summary

A. Item Selection

ACCELERATOR | DESCRIPTION OF COMMAND
Insert | Toggle the selection state (select if unselected and vice-versa) of the item under the (focus) cursor and move down
Ctrl + Space | Toggles selection as <Ins>, but won't move the focus cursor
Shift + Click | Extend the selection up to the clicked item
Ctrl + Click | Select/Unselect an individual item, without affecting the selection state of the remaining items
Alt + D | Select all (and only) folders
Alt+Shift+D | Unselect all selected folders
Drag-draw an enclosing rectangle ("lasso") with mouse | to select multiple rows simultaneously

B. Cursor Movement

You can change the focus manually by clicking with the left mouse button or with any of the following keys:

Accelerator | Description Of Command
Arrow keys | Move the focus cursor to the respective arrow direction
Home/End | Move the focus cursor to the beginning/end of list
PgUp/PgDn | Move the focus cursor a "page" (screenful) up/down
<letter> | Move and select the first item whose name begins with <letter>. Ø Works in tree pane also.
Shift+<letter> | Similar to the above but here the letter/substring is matched against the extension of filenames (useful for cases where a pane is sorted by extension)
<Substring> | Move and select the first item whose name begins with the substring. Ø Enter the string fast; otherwise the 2xExplorer acts on each individual letter of the string.
Alt + Down | Move the focus to the next item selected
Alt + Up | Move the focus to the previous item selected
Ctrl+Y | Synchronised Scrolling: a change in the focused item in the active pane is mirrored in the inactive pane, if possible. (i.e. if a file with the same name exists in the "other" pane it will be focused).

C. Pane Activation

Click anywhere on a pane to activate it.

Ø Click on the title bar to protect any previous selection pattern.

The two panes along with the folder history combo box in the address bar and the tree pane (if visible) can be considered as a "chain". Use the following keys to pass through this chain:

Accelerator | Description Of Command
Tab | Cycle between left/right panes
Left/Right | Arrows behave like <Tab> when both panes are set in details view
Shift + Tab | Jump to the folder history drop-down combo box
Ctrl + Tab | Jump to the file system tree pane
Esc/Tab (From within the folder combo box or folder tree) | Return to the active pane
<Alt+Tab> | Switch from the main 2xExplorer window to an editor/viewer window
<Alt+F6> | Hop on and off from modeless dialogs like the find file results or the folder data window

D. Folder Browsing

Accelerator | Description Of Command
Return | Select the folder.
Double-Click | Equivalent to Return (Select the folder).
Alt + F1 | Select drive for the left pane
Alt + F2 | Select drive for the right pane
Ctrl+Shift+<letter> | Jump to the root directory of the logical disk <letter> (e.g. <Ctrl+Shift+A> will take you to "A:\" etc.)
Double-click on a pane's titleBar | Take you up one level (Equivalent to the “..” button.)

Note: Hold down the <Alt> key to apply any command to the inactive pane.

In Tree pane:

Accelerator | Description Of Command
Return | Load the folder in the active pane.
Double-Click | Equivalent to Return: Load the folder in the active pane.
Left (right) arrow key | Expand (collapse) the tree branch.
+ (- ) key | Expand (collapse) the tree branch.
Ctrl+left arrow Ctrl+ right arrow | To scroll horizontally the tree nodes (e.g. in tight width situations)

Note: Hold down the <Alt> key to apply any command to the inactive pane.

NOTE: To use any shortcut that combines Alt and Ctrl keys (for example, Alt+Ctrl+0), you must press Alt before Ctrl.

E. The <CONTROL> Key Modifier

Use the <Ctrl> key with the standard command accelerator key, to bypass the popup dialog window of the command:

Accelerator | Description Of Command
Ctrl + F5 | Direct copy of selected items to the opposite pane
Ctrl + F6 | Direct move of selected items to the opposite pane
Ctrl + Grey[+] | Direct marking of items using the last selection pattern
Ctrl + Grey[-] | Direct unmarking of items using the last pattern
Ctrl + F3 | Use the internal viewer even when an external editor is specified in the general program options
Ctrl + F4 | Ditto for editing files

F. Dragging Modifiers

Right-dragging is supported in 2xExplorer.

While left-dragging, the default operation depends on the drop location (e.g. whether the source/target folders are on the same device, whether the dropped file is an executable, etc).

While left-dragging, use the following keys to manually force a particular operation:

Modifier | Forced File Operation
Ctrl | Copy items
Shift | Move items
Ctrl+Shift | Create links (shortcuts) to items
Right button | Cancels the drag altogether (same as pressing Esc)

Note that both the active/inactive panes as well as the tree pane can be either drag sources or drop targets, and they all support drag scrolling, too.

G. Command Execution From The Address Bar

Key combination | Effect
$ + <program name> + arguments > + <program name> + arguments | Execute a Windows or MS/DOS program (arguments are optional)
Ctrl + up/down/left/right arrows | Move the focus in the arrow direction in the active pane.
Ctrl + Return | Copy the name of the focused item from the active pane into the address bar
$L $R (Tokens within a command) | Substitutes the full path of the active folder in the left or right pane.
$N | Copies the focused filename in the command line. (For more reusable commands.)
Return | Execute the complete command
CTRL + F10 | Run command history

Execute a command with the standard windows executor (Start > Run), (or its shortcut <WinKey + R> ) to run programs that are not in the PATH variable.

H. Autocompletion For Combo Boxes

Key combination | Effect
Substring + <up-arrow> (In combo boxes, address bar, etc) | Autocompletion (Your “seed” text is matched against previously entered strings in the same box.) Ø Press up/down arrows to scroll through all matching entries.
<Alt+down-arrow>. | Expand the drop-down window


I. Miscellaneous Commands

  1. While dragging toolbars around, press <Ctrl> to prevent docking
  2. Double click on the splitter bar dividing the two panes to toggle viewing one pane or two equally sized panes.
  3. Drag any folder/file from your desktop and drop it onto the address bar to browse the target without typing the pathname.

Key combination | Effect
Esc | Aborts some lengthy operations as gathering "Folder Data"
Alt + Grey[-] | Similar to the Mark "Like this one" command <Alt+G[+]>, but for unselecting items
Shift + Del | Delete the selected items immediately without transfer to the Recycle bin (caution: this action can't be undone)
Right click | Shows a popup menu depending on context (what and where is selected). Ø The menu depends on type of the item (e.g. folder/ text file).
Shift+ right-click on item | The context menu will include an "Open with..." option.
Right clicking on items within "My Computer" folder | Gives access to many useful commands, like formatting floppy disks, etc
Right clicking on items within "Network Neighborhood" folder | Setting up, finding computers

Keyboard Shortcuts

Menu | Shortcut | Action
Files | F2 | Rename
 | F3 | View
 | F4 | Edit
 | F5 | Copy to..
 | F6 | Move to..
 | F12 | Properties
 | CTRL + J | Use filter
 | CTRL + H | Filter
 | Alt + X | Exit
 | Del | Delete
Mark | CTRL + A | Select all
 | Alt + A | Unselect all
 | Alt + S | Sticky selection
 | Grey + | Select group…
 | Grey - | Unselect group…
 | Grey * | Invert selection
 | F9 | Synchronize panes
 | CTRL + F9 | Locate identical
 | CTRL + M | Mirror browsing
 | CTRL + Y | Sync scrolling
 | CTRL + P | Scroll to top
 | CTRL + G | Containing text…
 | Alt + F9 | Sync on content
 | CTRL + B | Generate batch…
 | CTRL + F11 | Selection > Store
 | F11 | Selection > Select
 | Alt + F11 | Selection > Unselect
Edit | CTRL + Z | Undo
 | CTRL + C | Copy to clipboard
 | CTRL + X | Cut to clipboard
 | CTRL + V | Paste from clipboard
 | CTRL + L | Find target
 | Alt + C | Copy names
View | CTRL + S | Sort again
 | CTRL + R | Refresh
 | CTRL + I | Identical folder
 | CTRL + E | Equal panes
 | CTRL + O | One pane
 | CTRL + U | Swap panes
 | CTRL + Shift + 7 CTRL + Shift + 8 CTRL + Shift + 9 | Define layouts
 | CTRL + 7 CTRL + 8 CTRL + 9 | Activate the predefined layout.
 | CTRL + ALT + N | Sort by name
 | CTRL + ALT + S | Sort by Size
 | CTRL + ALT + D | Sort by Date
 | CTRL + ALT + T | Sort by Type
 | CTRL + ALT + U | Unsorted
 | CTRL + ALT + A | Sort in Ascending Order
Actions | F7 | New file
 | F8 | New folder
Bookmark | CTRL + Shift + 0 CTRL + Shift + 1 CTRL + Shift + 2 CTRL + Shift + 3 CTRL + Shift + 4 CTRL + Shift + 5 | Define bookmarks.
 | CTRL + 0 CTRL + 1 CTRL + 2 CTRL + 3 CTRL + 4 CTRL + 5 | Go to the defined bookmarks
Tools | CTRL + D | Folder data…
 | Alt + F1 | Select drive…
 | CTRL + F | Find files…
 | CTRL + T | System Tree
 | ALT + T | Locate in tree
 | F10 | DOS command
 | CTRL + F10 | Run history…
 | ALT + F10 | Repeat command

Lookup Table

Action | Command Path | Keyboard Shortcut
Activate the predefined layout. | View > Layouts | CTRL + 7
Activate the predefined layout. | View > Layouts | CTRL + 8
Activate the predefined layout. | View > Layouts | CTRL + 9
Auto re-sort after moving, copying, etc | View > Options.. > General | None
Automatic branch expansion when hovering on a node | View > Options..> Usability | None
Automatic shift focus to view after activation | View > Options..> Usability | None
Containing text… | Mark > Advanced > Containing text… | CTRL + G
Copy names | Edit > Copy names | Alt + C
Copy preview | Edit > Copy preview | None
Copy to clipboard | Edit > Copy to clipboard | CTRL + C
Copy to.. | Files > Copy to.. | F5
Cut to clipboard | Edit > Cut to clipboard | CTRL + X
Define bookmarks. | Bookmark > Define bookmarks. | CTRL + Shift + 0
Define bookmarks. | Bookmark > Define bookmarks. | CTRL + Shift + 1
Define bookmarks. | Bookmark > Define bookmarks. | CTRL + Shift + 2
Define bookmarks. | Bookmark > Define bookmarks. | CTRL + Shift + 3
Define bookmarks. | Bookmark > Define bookmarks. | CTRL + Shift + 4
Define bookmarks. | Bookmark > Define bookmarks. | CTRL + Shift + 5
Define layouts | View > Layouts | CTRL + Shift + 7
Define layouts | View > Layouts | CTRL + Shift + 8
Define layouts | View > Layouts | CTRL + Shift + 9
Delete | Files > Delete | Del
DOS command | Tools > DOS command | F10
Edit | Files > Edit | F4
Equal panes | View > Equal panes | CTRL + E
Exit | Files > Exit | Alt + X
Filter | Files > Filter | CTRL + H
Find files… | Tools > Find files… | CTRL + F
Find target | Edit > Find target | CTRL + L
Folder data… | Tools > Folder data… | CTRL + D
Generate batch… | Mark > Generate batch… | CTRL + B
Go to Control Panel | Bookmarks > Go to folder > Control Panel | None
Go to Desktop | Bookmarks > Go to folder > Desktop | None
Go to documents | Bookmarks > Go to folder > Documents | None
Go to network | Bookmarks > Go to folder > Network | None
Go to next | Bookmarks > Go to folder > Next | None
Go to Parent | Bookmarks > Go to folder > Parent | None
Go to previous | Bookmarks > Go to folder > Previous | None
Go to printers folder | Bookmarks > Go to folder > Printers | None
Go to Recycle bin | Bookmarks > Go to folder > Recycle bin | None
Go to root | Bookmarks > Go to folder > Root | None
Go to Start menu | Bookmarks > Go to folder > Start Menu | None
Go to Startup Menu | Bookmarks > Go to folder > Startup Menu | None
Go to the defined bookmarks | Bookmark > Go to the defined bookmarks | CTRL + 0
Go to the defined bookmarks | Bookmark > Go to the defined bookmarks | CTRL + 1
Go to the defined bookmarks | Bookmark > Go to the defined bookmarks | CTRL + 2
Go to the defined bookmarks | Bookmark > Go to the defined bookmarks | CTRL + 3
Go to the defined bookmarks | Bookmark > Go to the defined bookmarks | CTRL + 4
Go to the defined bookmarks | Bookmark > Go to the defined bookmarks | CTRL + 5
Grid lines in detailed mode | View > Options..> Usability | None
Identical folder | View > Identical folder | CTRL + I
Invert selection | Mark > Invert selection | Grey *
Keep tree in sync | Tools > Keep tree in sync | None
Locate identical | Mark > Locate identical | CTRL + F9
Locate in tree | Tools > Locate in tree | ALT + T
Maximum column width in list mode | View > Options..> Usability | None
Merge files | Actions > Merge Files | None
Mirror browsing | Mark > Advanced > Mirror browsing | CTRL + M
Move to.. | Files > Move to.. | F6
New file | Actions > New file | F7
New folder | Actions > New folder | F8
Number of history items maintained | View > Options.. > General | None
One pane | View > One pane | CTRL + O
Paste from clipboard | Edit > Paste from clipboard | CTRL + V
Paste hard link | Actions > Paste hard link | None
Paste shortcut | Edit > Paste shortcut | None
Properties | Files > Properties | F12
Refresh | View > Refresh | CTRL + R
Rename | Files > Rename | F2
Repeat command | Tools > Repeat command | ALT + F10
Run command.. | Tools > Run Command.. | None
Run history… | Tools > Run history… | CTRL + F10
Save program state on exit | View > Options.. > General | None
Save System Date as the file date | Actions > Touch dates | None
Scroll to top | Mark > Advanced > Scroll to top | CTRL + P
Select all | Mark > Select all | CTRL + A
Select appearance of Toolbars (Flat / Raised) | View > Options.. > General | None
Select drive… | Tools > Select drive… | Alt + F1
Select File time/date (created/modified/accessed); To show in details view | View > Options.. | None
Select group… | Mark > Select group… | Grey +
Select pane display style | View > Pane styles | None
Select viewer (internal / external) | View > Options.. > General | None
Selection > Select | Mark > Selection > Select | F11
Selection > Store | Mark > Selection > Store | CTRL + F11
Selection > Unselect | Mark > Selection > Unselect | Alt + F11
Set filters | Files > Filters… | None
Show drive letters on DriveBar | View > Options.. > General | None
Show hidden files | View > Options.. > General | None
Show infotips for items | View > Options..> Usability | None
Shred | Actions > Shred | None
Single-click activation | View > Options..> Usability | None
Sort again | View > Sort again | CTRL + S
Sort by Date | View > Sort by > Date | CTRL + ALT + D
Sort by name | View > Sort by > name | CTRL + ALT + N
Sort by Size | View > Sort by > Size | CTRL + ALT + S
Sort by Type | View > Sort by > Type | CTRL + ALT + T
Sort in Ascending Order | View > Sort by > Ascending Order | CTRL + ALT + A
Split File | Actions > Split file | None
Sticky selection | Mark > Sticky selection | Alt + S
Swap panes | View > Swap panes | CTRL + U
Sync on content | Mark > Advanced > Sync on content | Alt + F9
Sync scrolling | Mark > Advanced > Sync scrolling | CTRL + Y
Sync touch | Mark > advanced > Sync Touch | None
Synchronize panes | Mark > Synchronize panes | F9
System Tree | Tools > System Tree | CTRL + T
Undo | Edit > Undo | CTRL + Z
Unselect all | Mark > Unselect all | Alt + A
Unselect group… | Mark > Unselect group… | Grey -
Unsorted | View > Sort by > Unsorted | CTRL + ALT + U
Use filter | Files > Use filter | CTRL + J
View | Files > View | F3
View toolbars (show / hide) | View > Toolbars | None

Buttons

Navigation

Up one level (parent)

Go to root

Desktop

Previous

Next

My documents

Bookmark

Go to root/ Current

Network neighborhood

All drives, including mapped drives.

(Note the difference in symbols for Floppy drives, hard disks, removable disk drives and network drives.)

New text file (in the active pane)

New folder (in the active pane)

Display the properties of the selected item(s)

View file as text

Selection filters

Toggle sticky selection mode

(sticky = unaffected by keys and keys)

Select items according to supplied filter.

(Use CTRL for direct)

Unselect items according to supplied filter.

(Use CTRL for direct)

Toggle the selection state of items

(Selected ßà Unselected)

Toggle the visual filter (on/off)

Copy, move & Delete

Copy the selected items to opposite pane.

Move the selected items to opposite pane.

Send the selected items to recycle bin
(press SHIFT to delete permanently.)

Show/hide the tree of all system folders

Show/hide the Thumbnail Bar.

(Requires Active Desktop)

Load the same folder in the inactive pane.

(Press ALT for reverse-action.)

Refresh (re-read) the active pane items.

(Press ALT to refresh inactive pane.)

Toggle automatic mirror folder browsing for the two panes.

Select all items that differ among the panes.

Select files that contain the specified string.

Edit

Cut the selection and copy it to the clipboard.

Copy the selection and copy it to the clipboard.

Paste the clipboard contents.

Display

Display items using large icons.

Display items using small icons.

Display items in a list.

Show detailed information of items.

Sort Items

Sort items alphabetically, by name.

Sort by extension (by type)

Sort items by size

Sort items by date.

Ascending order.


Hacking the Registry

2xExplorer uses the system registry to store many program options. Everything you can control directly within 2x is stored there, but there are other settings that are controllable only by direct editing of the registry. This file describes some of the latter options that advanced users can tweak for better customisation.

*** WARNING ***

EDITING THE REGISTRY CAN RENDER YOUR COMPUTER UNUSABLE. UNLESS YOU ARE 100% CERTAIN YOU KNOW WHAT YOU ARE DOING, YOU ARE ADVICED NOT TO MODIFY IT IN ANY WAY.

If you are still reading this despite the above scaremongering <g>, then you would know about RegEdit.exe or other more advanced registry editors. Here's the drill:

1. EXIT 2xExplorer (this is essential)

2. Start regedit using Start | Run (or equivalent)

3. Locate the "key" where 2x keeps its settings

4. Double-click on a "variable" name to change its value

The default key is "HKEY_CURRENT_USER\Software\ZabaraKatranemia Plc\2xExplorer" but this may vary slightly if you are using the /S command line option (see Command Line Arguments). The settings are held in sub-keys of this primary key.

Most options have self-descriptive names, so it shouldn't be hard to imagine what each variable does. As a general further hint, names that begin with 'b' (e.g. bUnderline) refer to on/off (boolean) settings. Setting the value to 0 turns the option off, any other value enables it. Names starting with 'n' imply a number of some sort, and those with 'sz' are strings. Hungarian people talk like that, alledgedly <g>.

Here's a description of settings you may want to experiment with, organized by subkey:

[Editor/Viewer Settings] |
bHorizScroll | Adds a horizontal scroll bar, if necessary
bSelectionBar | Adds a small gap to the left acting like a selection margin
[General Settings] |
bUsePlainIcons | Makes the program faster by showing simple icons for files & folders
szDirPrintFormat | sprintf-like format string used for "printed" folder listings
bPlainBytesFormat | Set to 0 if you want "compressed" file size info (in kB/MB etc)
nMaxExtractSize | Size limit for files processed within zipfolders; set to 0 to prevent extraction altogether.
[Left Pane Settings] |
msFreeSpaceUpdateInterval | Time interval in milliseconds (1sec = 1000ms) between successive disk free space inquiries. (this is actually for both panes, not just the left)
[MainFrame Settings] |
bUpDownPanes | If set, folder panes are stacked one on top of the other, not left/right.
nFolderComboHeight | Height of the drop-down portion of the address bar in pixels.
nFolderComboWidth | Width of the above in pixels, used when the bar is floating or docked horizontally.
nMaxFileSizeThumb | Size limit in bytes for files whose thumbnails are generated.
szDosCmdPreample | String that is prepended to the DOS command you type to be executed in the address bar.
szShellCmdPreample | Ditto for "shell" commands (starting with '>')
msTreeAutoCDDelay | Delay in milliseconds before the autoCD mode kicks in (for single-click activation mode)


Credits

2xExplorer was developed using Visual C++ (utilising MFC classes), single-handedly by Nikos Bozinis in 1999-2002.

2xExplorer website: http://www.netez.com/2xExplorer

2xExplorer forum: http://www.netez.com/bbs/

Thanks out to (alpha-numerically sorted):

· Robert Helmer, for all his assistance spreading 2xExplorer on the net.

· Sal Pileggi, for providing free hosting for 2xExplorer's website and forum.

· Oliver Smith, whose CCoolDialogBar class provided the foundation for the dockable/resizable toolbar that hosts the filesystem tree view.

· Christian Storgaard, for coming up with that pukka icon design for 2xExplorer.